<?php
// +-----------------------------------------------------------------------+
// | FacebookPlug - a Piwigo Plugin                                        |
// | Copyright (C) 2010 Ruben ARNAUD - rub@piwigo.org                      |
// +-----------------------------------------------------------------------+
// | This program is free software; you can redistribute it and/or modify  |
// | it under the terms of the GNU General Public License as published by  |
// | the Free Software Foundation                                          |
// |                                                                       |
// | This program is distributed in the hope that it will be useful, but   |
// | WITHOUT ANY WARRANTY; without even the implied warranty of            |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU      |
// | General Public License for more details.                              |
// |                                                                       |
// | You should have received a copy of the GNU General Public License     |
// | along with this program; if not, write to the Free Software           |
// | Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, |
// | USA.                                                                  |
// +-----------------------------------------------------------------------+

if (!defined('PHPWG_ROOT_PATH'))
{
  die('Hacking attempt!');
}

include_once(FBP_DIR.'/include/common.inc.php');
include_once(FBP_DIR.'/include/header.inc.php');

function fbp_render_element_content($content, $current_picture)
{
  global $template, $user, $page, $conf, $picture;

  if ($page['slideshow'] and $conf['fbp']['social_plugin_facepile']['enabled'])
  {
    $tpl = 'social.plugin.facepile';
  }
  else if (! $page['slideshow'])
  {
    if ($conf['fbp']['social_plugin_like_button']['enabled'])
    {
      $tpl = 'social.plugin.like.button';
    }
    else if ($conf['fbp']['social_plugin_comments']['enabled'])
    {
      $tpl = 'social.plugin.comments';
    }
  }

  if (empty($tpl))
  {
    // nothing to do
    return $content;
  }

  // define picture FB link
  // Always use full url for FB social plugin
  set_make_full_url();
  if ($conf['fbp']['picture_url_type'] == 'image')
  {
    $fbp_url_picture = get_element_url($current_picture);
  }
  else
  {
    $fbp_url_picture = make_picture_url(array('image_id' => $page['image_id']));
  }
  unset_make_full_url();
  $template->assign('fbp_url_picture', $fbp_url_picture);
  $template->assign('fbp_urlencode_picture', urlencode($fbp_url_picture));

  // XFBML implementation
  $template->set_filename($tpl, FBP_DIR.'/tpl/'.$tpl.'.tpl');
  $content .= $template->parse($tpl, true);

  return $content;
}

function ftp_loc_end_section_init()
{
  global $conf;

  if ($conf['fbp']['social_plugin_like_button']['enabled'] or $conf['fbp']['social_plugin_comments']['enabled'])
  {
    if ($conf['fbp']['allow_fb_access_private_page'])
    {
      global $user, $page;

      // No restristion for facebook user
      if (preg_match('/'.FBP_IP_FB. '/', $_SERVER["REMOTE_ADDR"]))
      {
        //Allow guest access
        $conf['guest_access'] = true;
        // No forbidden categorie
        $user['forbidden_categories'] = '';
        $user['level'] = max($conf['available_permission_levels']);
        $page['rank_of'][$page['image_id']] = 0;
        $page['items'] = array_flip($page['rank_of']);
      }
    }
  }
}

if ($conf['fbp']['social_plugin_like_button']['enabled'] or $conf['fbp']['social_plugin_facepile']['enabled'] or $conf['fbp']['social_plugin_comments']['enabled'])
{
  //~ add_event_handler('loc_begin_picture', 'fbp_loc_begin_picture');
  add_event_handler('render_element_content', 'fbp_render_element_content', EVENT_HANDLER_PRIORITY_NEUTRAL+1 /*in order to have picture content*/, 2);
  //~ add_event_handler('loc_end_picture', 'fbp_loc_end_picture');
  add_event_handler('loc_end_section_init', 'ftp_loc_end_section_init');
}

?>
